
#ifndef DFONT_H
#define DFONT_H

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <iostream>
#include <fstream>
#include <map>

using namespace std;

//The following enum is for getting text centered horizontally or 
//vertically.  They are passed as X, Y values to the PutChar/PutString
//functions.

enum {CTR_HORIZ=-1, CTR_VERT=-2};

Uint32 GetPixel (SDL_Surface *, Sint32, Sint32);

class DFont 
{
 protected:
  map <char, SDL_Rect> fonts;
  SDL_Surface * fontSurface;
  int gap;

 private:
  void initMap (const char *);	
  void loadMap (const char *); 
  void loadImage (const char *);

 public:
 	 DFont ();		
 	 DFont (const char *, const char * );		
 	 ~DFont ();

   void load(const char *);
   void PutString(SDL_Surface *, Sint16 , Sint16 , const char * );
   void PutChar(SDL_Surface *, Sint16, Sint16, char);
   void PutInt(SDL_Surface *, Sint16, Sint16, int);
   Sint16 StringWidth(const char *);
   Sint16 CharHeight();  //all characters have the same height
};

ostream& operator << (ostream & , SDL_Rect const &);//output a record
istream& operator >> (istream & , SDL_Rect &);//input a record
#endif


